// *** function to replace href="#" ***
function v(){
	return;
}

// *** Cookies ***
function writeCookie(name, value) { 
	exp = new Date(); 
	exp.setTime(exp.getTime() + (86400 * 1000 * 30));
	document.cookie = name + "=" + escape(value) + "; expires=" + exp.toGMTString() + "; path=/"; 
} 
function readCookie(name) { 
	var search; 
	search = name + "="; 
	offset = document.cookie.indexOf(search); 
	if (offset != -1) { 
		offset += search.length; 
		end = document.cookie.indexOf(";", offset); 
		if (end == -1){
			end = document.cookie.length;
		}
		return unescape(document.cookie.substring(offset, end)); 
	}else{
		return "";
	}
}

////////////////////////////////////
// Language
////////////////////////////////////
function lang(label){
  document.write(arrLang[label]);
}

////////////////////////////////////
// StyleSheet
////////////////////////////////////
function writeCSS(){
  for(var i=0;i<arrCSS.length;i++){
    document.write('<link title="css'+i+'" href="'+arrCSS[i][1]+'" rel="stylesheet" disabled="true" type="text/css" />');
  }
	setStyleSheet(readCookie("stylesheet"));
}

function writeCSSLinks(){
  for(var i=0;i<arrCSS.length-1;i++){
    if(i>0) document.write(' | ');
    document.write('<a href="javascript:v()" onclick="setStyleSheet(\'css'+i+'\')">'+arrCSS[i][0]+'</a>');
  }
}

function setStyleSheet(strCSS){
  var objs=document.getElementsByTagName("link");
  var intFound=0;
  for(var i=0;i<objs.length;i++){
    if(objs[i].type.indexOf("css")>-1&&objs[i].title){
      objs[i].disabled = true;
      if(objs[i].title==strCSS) intFound=i;
    }
  }
  objs[intFound].disabled = false;
  writeCookie("stylesheet",objs[intFound].title);
}

////////////////////////////////////
// Search engines
////////////////////////////////////
var activeTab=0;

// *** Output Search Engine List ***
function writeTabs(){
  var obj=document.getElementById("navtabs");
  for(var i=0;i<arrSearch.length-1;i++){
    obj.innerHTML+=('<li><a href="javascript:v()" onclick="clickTab('+i+');this.blur()">' + arrSearch[i][0] + '</a></li>\n');
  }
}

// *** Output Search Engine List ***
function clickTab(tabNum){
	var obj=document.getElementById("navtabs");
	var objs=obj.getElementsByTagName("A");
	for(var i=0;i<objs.length;i++){
		objs[i].className="";
    if(i==tabNum) objs[i].className="active";
	}
	activeTab=tabNum;
  obj=document.getElementById("searchLabel");
  if(arrSearch[activeTab][2]){
    obj.innerHTML=arrSearch[activeTab][2];
  }else{
    obj.innerHTML=arrSearch[activeTab][0];
  }
  document.searchForm.q.focus();
}

// *** Call the search engine ***
function doSearch(){
	var tip=arrLang["askforkeyword"];
	if(document.searchForm.q.value!=""&&document.searchForm.q.value!=tip){
		window.open(arrSearch[activeTab][1].replace("%s",encodeURI(document.searchForm.q.value)));
		return false;
	}else{
		document.searchForm.q.value=tip;
		document.searchForm.q.focus();
		document.searchForm.q.select();
		return false;
	}
}

////////////////////////////////////
// Panels
////////////////////////////////////
function toggleContent(objA){
  var obj=objA.parentElement.parentElement;
  var objs=obj.getElementsByTagName("DIV");
	for(var i=0;i<objs.length;i++){
    if(objs[i].className=="panel-content"){
      if(objs[i].style.display!="none"){
        objs[i].style.display="none";
      }else{
        objs[i].style.display="block";
      }
    }
	}
}

////////////////////////////////////
// Links Panel
////////////////////////////////////
function getRemoteLinks(){
  var obj=document.getElementById("maxLinks").getElementsByTagName("DIV")[0];
  obj.innerHTML='<span class="comment">'+arrLang["loading"]+'</span>';
  if(!simpleAjax.get("maxlinks",strLinks,outputLinks,{"responseType": 0})){
    obj.innerHTML='<span class="comment">'+arrLang["load_error"]+'('+simpleAjax.error.description+')</span>';
  }
}

function outputLinks(id,result,status,statusText){
  var obj=document.getElementById("maxLinks").getElementsByTagName("DIV")[0];
  if(result){
    obj.innerHTML=simpleAjax.result[id];
  }else{
    obj.innerHTML='<span class="comment">'+arrLang["load_error"]+'('+status+':'+statusText+')</span>';
  }
}

////////////////////////////////////
// Feed Panels
////////////////////////////////////
// *** Write feed panels ***
function writeFeedPanels(){
  for(var i=0;i<arrFeed.length-1;i++){
    	document.write('<div class="panel" id="feed'+i+'">\n'+
		    '<h5><a href="javascript:v()" onclick="toggleContent(this);this.blur()">'+arrLang["feed"]+': '+arrFeed[i][0]+'</a></h5>\n'+
    		'<div class="panel-content"></div>\n'+'</div>\n');
  }
}

// *** Load all feeds ***
function loadAllFeeds(){
  for(var i=0;i<arrFeed.length-1;i++){
    loadFeed(i);
  }
}

// *** Load one feed ***
function loadFeed(id){
  var obj=document.getElementById("feed"+id);
  if(obj){
    var obj=obj.getElementsByTagName("DIV")[0];
    obj.innerHTML='<span class="comment">'+arrLang["loading"]+'</span>';
    if(!simpleAjax.load(id,arrFeed[id][1],outputFeed,0)){
      obj.innerHTML='<span class="comment">'+arrLang["load_error"]+'('+simpleAjax.error.number+':'+simpleAjax.error.description+')</span>';
    }
  }
}

// *** Output feed content ***
function outputFeed(id,result,errorCode,errorText){
  if(result){
    fillFeedData(id, simpleFeedParser.parse(simpleAjax.result[id]));
  }else{
    var obj=document.getElementById("feed"+id);
    obj.getElementsByTagName("DIV")[0].innerHTML='<span class="comment">'+arrLang["load_error"]+'('+errorCode+':'+errorText+')</span>';
  }
}

// *** Fill feed data ***
function fillFeedData(id,objFeed){
  if(typeof(objFeed)=="string"){
    var obj=document.getElementById("feed"+id);
    obj.getElementsByTagName("DIV")[0].innerHTML='<span class="comment">'+arrLang["parse_error"]+'('+objFeed+')</span>';
  }else{
    var outputHTML="";
    if(objFeed.items.length>0){
      for(var i=0;i<objFeed.items.length;i++){
        outputHTML+='<li><a href="javascript:v()" onclick="toggleFeedContent(this);this.blur()">'+objFeed.items[i].title+'</a>'+
          ' &nbsp;<a href="'+objFeed.items[i].link+'" target="_blank" class="feed-more">&raquo;</a>\n'+
          '<div class="feed-content" style="display:none">\n'+objFeed.items[i].description+'\n</div></li>\n';
      }
    }else{
      outputHTML='<li>'+arrLang["no_content"]+'</li>';
    }
    outputHTML='<div class="feed-box">\n<ul>\n'+outputHTML+'</ul>\n</div>\n';
    var obj=document.getElementById("feed"+id);
    obj.getElementsByTagName("H5")[0].innerHTML='<span class="feed-control">'+
      '<a href="javascript:v()" onclick="toggleAllItems('+id+',true);this.blur()">+</a>'+
      ' &nbsp;<a href="javascript:v()" onclick="toggleAllItems('+id+',false);this.blur()">-</a></span>'+
      '<a href="javascript:v()" onclick="toggleContent(this);this.blur()">'+objFeed.title+'</a>'+
      ' &nbsp;<a href="'+objFeed.link+'" target="_blank">&raquo;</a> ';
    obj.getElementsByTagName("DIV")[0].innerHTML=outputHTML;
  }
}

// *** toggle show/hide a single feed content ***
function toggleFeedContent(objA){
  var obj=objA.parentElement;
  var objs=obj.getElementsByTagName("DIV");
	for(var i=0;i<objs.length;i++){
    if(objs[i].className=="feed-content"){
      if(objs[i].style.display!="none"){
        objs[i].style.display="none";
      }else{
        objs[i].style.display="block";
      }
    }
	}
}

// *** toggle show/hide feed content by feed id***
function toggleAllItems(id,bShow){
  var objs=document.getElementById("feed"+id);
  objs=objs.getElementsByTagName("DIV");
	for(var i=0;i<objs.length;i++){
    if(objs[i].className=="feed-content"){
      if(!bShow){
        objs[i].style.display="none";
      }else{
        objs[i].style.display="block";
      }
    }
	}
}